/* xtdio.h: an external header file for the pattern matching routines */
#ifndef XTDIO_H
#define XTDIO_H

#ifdef __cplusplus
extern "C" {
#endif

/* --------------------------------------------------------------------------
 * Includes:
 */

#if defined(AIX)
# include <string.h>
# include <stdarg.h>
# include <stdlib.h>
# ifndef unix
#  define unix
# endif

#elif defined(apollo)
# include <string.h>
# include <stdarg.h>
# include <stdlib.h>

#elif defined(__BORLANDC__)
# define  msdos
# include <stdio.h>
# include <stdlib.h>
# include <stdarg.h>
# include <string.h>
# include <time.h>

#elif defined(__DECC) || defined(__alpha) || defined(__osf__)
# include <string.h>
# include <stdlib.h>
# include <stdarg.h>

#elif defined(__linux)
# include <string.h>
# include <stdlib.h>
# include <stdarg.h>
# if defined(__STRICT_ANSI__) && !defined(__USE_POSIX)
	 extern FILE *fdopen __P ((int, __const char *));
	 extern int fileno __P ((FILE*));
	 extern FILE* popen __P ((__const char*, __const char*));
	 extern int pclose __P ((FILE*));
# endif

#elif defined(MCH_AMIGA)
# include <string.h>
# include <stdlib.h>
# include <stdarg.h>

#elif defined(__MSDOS__)
# define msdos
# ifndef MSDOS
#  define MSDOS
# endif
# ifndef msdos
#  define msdos
# endif
# include <stdio.h>
# include <stdlib.h>
# include <stdarg.h>
# include <string.h>
# include <time.h>

#elif defined(sgi)
# ifdef __MALLOC_DBG_H__
#  include "mallocdbg2.h"
# else
#  include <strings.h>
#  include <stdlib.h>
# endif
# include <stdarg.h>

#elif defined(sun)
# include <string.h>
# include "xstdlib.h"
# include "varargs.h"

#elif defined(ultrix)
/* # define OldUltrix */
# ifdef OldUltrix
#  include <string.h>
#  include <stdlib.h>
#  include <varargs.h>
# else
#  include <strings.h>
#  include <stdlib.h>
#  include <stdarg.h>
# endif

#elif defined(vms)

# ifndef __STDIO_LOADED
#  ifndef oldvms
#   define oldvms 1
#  endif
# endif

# ifdef oldvms
#  include "xstdlib.h"
#  include "xvarargs.h"
#  define  defined(x) 0
#  define  strtok stptok

# else	/* new vms */
#  include <string.h>
#  include <stdlib.h>
#  include <stdarg.h>
#  define fgets(s,n,fp)			vmsfgets(s,n,fp)
#  define read(fp,buf,bufsiz)	vmsread(fp,buf,bufsiz)
#  ifndef __DESCRIP_LOADED
#   include <descrip.h>
    typedef struct dsc$descriptor DESC;
#  endif
# endif
# define system(cmd) vms_system(cmd)

#endif

#ifndef __STDIO_H__
# include <stdio.h>
#endif

#include "setproto.h"		/* sets __PROTOTYPE__ */

/* --------------------------------------------------------------------- */

/* standard Dr. Chip includes */
#include "getarg.h"
#include "links.h"
#include "rdcolor.h"
#ifndef EXIT
# define EXIT(rc) exit(rc)
#endif

#ifdef ultrix
# define const
#endif

/* -------------------------------------------------------------------------
 * Definitions:
 */
#define isoct(c) ('0' <= (c) && (c) <= '7')
#define ishex(c) \
 (isdigit(c) || ('a' <= (c) && (c) <= 'f') || ('A' <= (c) && (c) <= 'F'))

/* error support */
#define XTDIO_SEVERE		0
#ifndef XTDIO_ERROR
# define XTDIO_ERROR		1
#endif
#ifndef XTDIO_WARNING
# define XTDIO_WARNING	2
#endif
#define XTDIO_NOTE		3
#define XTDIO_USAGE		4
#define XTDIO_ERRORMORE	5

#ifndef USE_ESCAPES
# define USE_ESCAPES		1
#endif

/* stcmpma support */
#define MTCHMAX 10

/* ---------------------------------------------------------------------
 * Machine Dependent Defines:
 */
#ifdef MCH_AMIGA
# define system(cmd)			SyStem(cmd)
# define bzero(obj,nbytes)		memset(obj,0,nbytes)
# define bcopy(tgt,src,nbytes)	memcpy(tgt,src,nbytes)
#endif

#ifdef sun
# define const
#endif

/* ------------------------------------------------------------------------
 * Typedefs:
 */

/* -------------------------------------------------------------------------
 * Global Variables:
 */

/* fopenv/fopenx support */
extern char *fopenvfile;
extern char *fopenxfile;

/* rdcolor support */
extern int   screenheight;						/* rows    in display								*/
extern int   screenwidth;						/* columns in a line available to matdisp			*/
extern int   use_escapes;						/* (don't) use ANSI escape sequences				*/

/* outofmem and error support */
#ifdef __PROTOTYPE__
extern void (*error_exit)(int);
#else
# define const
extern void (*error_exit)();
#endif

extern FILE *errfp;

#ifdef __cplusplus
	}
#endif

/* ---------------------------------------------------------------------
 * Prototypes
 */
#include "proto.h"
#endif
